/* 
	 Written by: Vinay Chhabra
	 Presented by: www.universalteacher.com
	 e-mail:teachers@universalteacher.com

*/



import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;


public class ImagePanel extends JPanel	{  

	public ImagePanel()
	{
	super();	
		
	}	
					
						
	public void paintComponent(Graphics g)
   {  super.paintComponent(g);
   
      if (image != null)
       {
       	 g.drawImage(image, 0, 0, this);
       	}
          
      
   }
 
   	
		
   public void loadImage(String name)
   {  Image loadedImage
         = Toolkit.getDefaultToolkit().getImage(name);
      MediaTracker tracker = new MediaTracker(this);
      tracker.addImage(loadedImage, 0);
      try { tracker.waitForID(0); }
      catch (InterruptedException e) {}
      image = new BufferedImage(loadedImage.getWidth(null),
      loadedImage.getHeight(null), BufferedImage.TYPE_INT_RGB);
      Graphics2D g2 = image.createGraphics();
      g2.drawImage(loadedImage, 0,0, null);
     
      repaint();
   }

   private void filter(BufferedImageOp op)
   {  BufferedImage filteredImage
         = new BufferedImage(image.getWidth(), image.getHeight(),
            image.getType());
      op.filter(image, filteredImage);
      image = filteredImage;
      repaint();
   }

   private void convolve(float[] elements)
   {  Kernel kernel = new Kernel(3, 3, elements);
      ConvolveOp op = new ConvolveOp(kernel);
      filter(op);
   }

   public void blur(){  
   	
   		if(image==null)return;
   			
   	  float weight = 1.0f/9.0f;
      float[] elements = new float[9];
      for (int i = 0; i < 9; i++)
         elements[i] = weight;
      convolve(elements);
   }
   
   public void sharpen()
   {  
   	
 		if(image==null)return;

   	float[] elements =
         {  0.0f, -1.0f, 0.0f,
            -1.0f,  5.f, -1.0f,
            0.0f, -1.0f, 0.0f
         };
      convolve(elements);
   }

   void edgeDetect()
   {  
   	
 		if(image==null)return;

   	float[] elements =
         {  0.0f, -1.0f, 0.0f,
            -1.0f,  4.f, -1.0f,
            0.0f, -1.0f, 0.0f
         };
      convolve(elements);
   }

   public void brighten()
   {  
 			if(image==null)return;

	   	float a = 1.5f;
      float b = -20.0f;
      RescaleOp op = new RescaleOp(a, b, null);
      filter(op);
   }

   public void negative(){  
   	
	 		if(image==null)return;

  	 	byte negative[] = new byte[256];
      for (int i = 0; i < 256; i++)
         negative[i] = (byte)(255 - i);
      ByteLookupTable table = new ByteLookupTable(0, negative);
      LookupOp op = new LookupOp(table, null);
      filter(op);
   }

   public void rotate(){  
   	
 		if(image==null)return;

   	AffineTransform transform
         = AffineTransform.getRotateInstance(Math.toRadians(5),
            image.getWidth() / 2, image.getHeight() / 2);
      AffineTransformOp op = new AffineTransformOp(transform,
         AffineTransformOp.TYPE_BILINEAR);
      filter(op);
   }
   
   public void effect1(){  
   	
   		if(image==null)return;
   			
   	  float weight = 1.0f/20.0f;
      float[] elements = new float[9];
      for (int i = 0; i < 9; i++)
         elements[i] = weight;
      convolve(elements);
   }
   
   
   public void effect2(){  
   	
   		if(image==null)return;
   			
   	  float weight = 10.0f/20.0f;
      float[] elements = new float[15];
      for (int i = 0; i < 15; i++)
         elements[i] = weight;
      convolve(elements);
   }

 public void effect3(){  
   	
   		rotate();
   		negative();
   }


public void effect4(){  
   	
	 		if(image==null)return;

  	 	byte negative[] = new byte[25];
      for (int i = 0; i < 25; i++)
         negative[i] = (byte)(24 - i);
      ByteLookupTable table = new ByteLookupTable(0, negative);
      LookupOp op = new LookupOp(table, null);
      filter(op);
   }

   

   private BufferedImage image;
}