
/* 
	 Written by: Vinay Chhabra
	 Presented by: www.universalteacher.com
	 e-mail:teachers@universalteacher.com

*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;

public class ImageProcessor extends JFrame{  
	
	 public ImageProcessor(){  
	 	
	 	setTitle("Mini Image Processor presented by www.universalteacher.com");
    
      addWindowListener(new WindowAdapter(){  
      		public void windowClosing(WindowEvent e){  
         			System.exit(0);
            }
       } );
      
      contentPane = getContentPane();
      panel = new ImagePanel();
      panel.loadImage("FlashImage.jpg");
     
      scrollPane=new JScrollPane(panel);
      contentPane.add(scrollPane);
      
      JMenuBar menuBar = new JMenuBar();
      setJMenuBar(menuBar);
      
      
      JMenu fileMenu = SwingComp.createMenu(menuBar,"File");
      JMenu effectsMenu = SwingComp.createMenu(menuBar,"Effects");
      JMenu helpMenu = SwingComp.createMenu(menuBar,"Help");

      
      MenuHandler mnHandler = new MenuHandler();
      
      openItem = SwingComp.createMenuItems(fileMenu,mnHandler,"Open");
      exitItem = SwingComp.createMenuItems(fileMenu,mnHandler,"Exit");

      blurItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Blur");
      sharpenItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Sharpen");
      brightenItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Brighten");
      edgeDetectItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Edge detect");
      negativeItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Negative");
      rotateItem = SwingComp.createMenuItems(effectsMenu,mnHandler,"Rotate");
      
      
      JMenu otherEffects = SwingComp.createMenu(effectsMenu,"Other Effects");
      effect1 = SwingComp.createMenuItems(otherEffects,mnHandler,"Effect1");
			effect2 = SwingComp.createMenuItems(otherEffects,mnHandler,"Effect2");
			effect3 = SwingComp.createMenuItems(otherEffects,mnHandler,"Effect3");
			effect4 = SwingComp.createMenuItems(otherEffects,mnHandler,"Effect4");
			
			about = SwingComp.createMenuItems(helpMenu,mnHandler,"About");

			
                 
      this.setMDISize();
   }


		//-----method to set size of MDIForm
    	private void setMDISize()
    		{
        	//get the default toolkit to interact with operating system
        	Toolkit tk=Toolkit.getDefaultToolkit();
        	Dimension d=tk.getScreenSize();
        	int screenHeight=d.height;
        	int screenWidth=d.width;
        	this.setSize(screenWidth,screenHeight);

    		}
    		
    		
    		

private class MenuHandler implements ActionListener{

   public void actionPerformed(ActionEvent evt)
   {  Object source = evt.getSource();
   
      if (source == openItem)
      {  JFileChooser chooser = new JFileChooser();
         chooser.setCurrentDirectory(new File("."));

         chooser.setFileFilter(new
            javax.swing.filechooser.FileFilter()
            {  public boolean accept(File f)
               {  String name = f.getName().toLowerCase();
                  return name.endsWith(".gif")
                     || name.endsWith(".jpg")
                     || name.endsWith(".jpeg")
                     || f.isDirectory();
               }
               public String getDescription()
               {  return "Image files";
               }
            });

         int r = chooser.showOpenDialog(ImageProcessor.this);
         if(r == JFileChooser.APPROVE_OPTION)
         {  String name
               = chooser.getSelectedFile().getAbsolutePath();
            panel.loadImage(name);
                       
         }
      }
      
      else if (source == exitItem) System.exit(0);
      
      else if (source == blurItem) panel.blur();
      
      else if (source == sharpenItem) panel.sharpen();
      
      else if (source == brightenItem) panel.brighten();
      
      else if (source == edgeDetectItem) panel.edgeDetect();
      
      else if (source == negativeItem) panel.negative();
      
      else if (source == rotateItem) panel.rotate();
      
      else if (source == effect1) panel.effect1();
      
      else if (source == effect2) panel.effect2();
			
			else if (source == effect3) panel.effect3();
			
			else if (source == effect4) panel.effect4();
			
			else if (source == about){
				String message  = "Written by: Vinay Chhabra\nURL: www.universalteacher.com\ne-mail: vinay_chhabra@hotmail.com or \nteachers@universalteacher.com";
				JOptionPane.showMessageDialog(ImageProcessor.this,message,"Information",
													JOptionPane.INFORMATION_MESSAGE);
			}

   }
   
}

   private ImagePanel panel;
   
   private JMenuItem openItem,exitItem,blurItem,sharpenItem,brightenItem,edgeDetectItem,
   negativeItem, rotateItem,effect1,effect2,effect3,effect4,about;
   
   private JScrollPane scrollPane=null;
	 private Container contentPane;
}