/* 
	 Written by: Vinay Chhabra
	 Presented by: www.universalteacher.com
	 e-mail:teachers@universalteacher.com

*/
 
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;

//Factory class used to create swing components
//
public class SwingComp{
	
  //private constructor
  private SwingComp(){
  	System.out.println("Cannot create object");
  }
           
   
  

  //Creates a menu item with specified text. 
  //The method adds the menu item to the specified menu 
  //and adds the given listener to the menuitem.
  //       
  public static JMenuItem createMenuItems(JMenu mnu,ActionListener listener,String text){
   	
    JMenuItem mi = new JMenuItem(text);	
    mi.addActionListener(listener);	
    mnu.add(mi);
    return mi;   		
  }
  
  
  public static JMenuItem createMenuItems(JMenu mnu,ActionListener listener,
  							String text,String actionCommand){
   	
   	JMenuItem mi = new JMenuItem(text);	
    mi.addActionListener(listener);	
    mi.setActionCommand(actionCommand);
    mnu.add(mi);
    return mi;   		
  }

   
  //Creates a menu with given text and adds the 
  //menu to the specified menu bar.
  //
  public static JMenu createMenu(JMenuBar mBar, String text){
   	 
   	 JMenu mnu = new JMenu(text);
   	 mBar.add(mnu);
   	 return mnu;
   }
   

  public static JMenu createMenu(JMenu mnuParent, String text){
   	 
   	 JMenu mnu = new JMenu(text);
   	 mnuParent.add(mnu);
   	 return mnu;
   }

 
 public static JPanel createPanel(Container cp){
 	
	 	JPanel panel =new JPanel();
	 	cp.add(panel);
	 	return panel;
 }

 //Constructs a panel. 
 //The method adds the panel object to the givent container 
 //using the specified constraints object.
 //
 public static JPanel createPanel(Container cp,String placement){
 	
	 	JPanel panel =new JPanel();
	 	cp.add(panel,placement);
	 	return panel;
 }

 //Constructs a panel with specified layout manager.
 //The method adds the panel object to the givent container 
 //using the specified constraints object.
 //	 
 public static JPanel createPanel(Container cp,String placement,LayoutManager manager){
   	
	  JPanel panel =new JPanel(manager);
	 	cp.add(panel,placement);
	 	return panel;
 }
  
 
 
  
 public static JScrollPane createScrollPane(Container cp,Component comp,String pos){
 	JScrollPane sp = new JScrollPane(comp);
 	cp.add(sp,pos);
 	return sp;
 	
 }
 
 public static JScrollPane createScrollPane(Container cp,Component comp){
 	JScrollPane sp = new JScrollPane(comp);
 	cp.add(sp);
 	return sp;
 	
 }

 
 
}

     
        